
/*
*	Callbacks: Function handlers for everything that has s signal connect in interface.h
*/


#ifndef __IMAGER_CALLBACKS_H
#define __IMAGER_CALLBACKS_H

#include "defs.h"


	/* file menu */

void on_open1_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_open_multiple1_activate (GtkMenuItem *menuitem, gpointer  user_data);
void on_import1_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_rgbload1_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_save1_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_close1_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_prefs1_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_quit1_activate (GtkMenuItem *menuitem, gpointer  user_data);

	/* edit menu */

void on_undo_activate (GtkMenuItem *menuitem, gpointer  user_data);
void on_trimimg_activate (GtkMenuItem *menuitem, gpointer  user_data);
void on_edit2_activate (GtkMenuItem *menuitem, gpointer  user_data);
void on_edit3_activate (GtkMenuItem *menuitem, gpointer  user_data);
void on_edit4_activate (GtkMenuItem *menuitem, gpointer  user_data);
void on_edit5_activate (GtkMenuItem *menuitem, gpointer  user_data);
void on_values_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_rebin_activate  (GtkMenuItem *menuitem, gpointer  user_data);

	/* View menu */

void on_magnifier_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_surfplot_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_lookup_activate   (GtkMenuItem *menuitem, gpointer  user_data);
void on_colormap_activate   (GtkMenuItem *menuitem, gpointer  user_data);
void on_viewmip_activate (GtkMenuItem *menuitem, gpointer  user_data);
void on_viewprofile_activate (GtkMenuItem *menuitem, gpointer  user_data);
void on_viewlinesumx_activate (GtkMenuItem *menuitem, gpointer  user_data);
void on_viewlinesumy_activate (GtkMenuItem *menuitem, gpointer  user_data);
void on_viewzslab_activate (GtkMenuItem *menuitem, gpointer  user_data);
void on_viewstatop_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_viewbc_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_viewcontours_activate (GtkMenuItem *menuitem, gpointer user_data);

	/* Process menu */

void on_invrt_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_process2_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_process4_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_threshold1_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_threshold2_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_threshold3_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_threshold4_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_threshold5_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_threshold6_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_skeletonize_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_morphop_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_fillholes_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_centerfeat_activate (GtkButton  *button, gpointer user_data);
void on_uep_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_runlength_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_convolve_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_afilter_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_fft_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_ifft_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_dht_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_idht_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_fft_rose_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_fourierfilt_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_process6_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_imgmath_activate  (GtkMenuItem *menuitem, gpointer  user_data);
void on_hough_activate  (GtkMenuItem *menuitem, gpointer  user_data);

	/* Segment menu */

void on_spiderop_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_snakeop_activate_0 (GtkMenuItem *menuitem, gpointer user_data);
void on_snakeop_activate_1 (GtkMenuItem *menuitem, gpointer user_data);
void on_snakeop_activate_2 (GtkMenuItem *menuitem, gpointer user_data);
void on_hystthresh_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_watershed_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_regiongrow_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_growmerge_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_kmeans_activate (GtkMenuItem *menuitem, gpointer user_data);

	/* Measure menu */

void on_stats_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_bound_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_clustcnt_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_fractdim_activate (GtkMenuItem *menuitem, gpointer user_data);

	/* Special Menu */

void on_wedge_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_bonedens_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_vertebrae_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_vesselanalysis_activate (GtkMenuItem *menuitem, gpointer user_data);

	/* Macros menu */
	
void on_loadmacro_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_delmacro_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_immdtmacro_activate (GtkMenuItem *menuitem, gpointer user_data);

	/* Help menu */

void on_help1_activate   (GtkMenuItem *menuitem, gpointer  user_data);
void on_about1_activate   (GtkMenuItem *menuitem, gpointer  user_data);
void on_imginfo1_activate   (GtkMenuItem *menuitem, gpointer  user_data);
void on_license1_activate   (GtkMenuItem *menuitem, gpointer  user_data);
void on_pidinfo_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_relnotes_activate (GtkMenuItem *menuitem, gpointer user_data);

	/* Accel buttons and other non-menu elements */

void on_button1_clicked   (GtkButton   *button, gpointer  user_data);
void on_button2_clicked   (GtkButton   *button, gpointer  user_data);
void on_button3_clicked   (GtkButton   *button, gpointer  user_data);
void on_stopbutton_clicked (GtkButton *button, gpointer  user_data);

void on_slice_spinbutton_changed (GtkButton *button, gpointer user_data);
void on_zoom_changed (GtkButton *button, gpointer user_data);


	/* Signals that originate from the main display window */

void signal_close_file ();

void pixbuf_destroy_handler (guchar *pixelptr, void *user_data);

gboolean on_drawingarea1_expose_event (GtkWidget *widget, GdkEventExpose  *event, gpointer  user_data);

gboolean on_drawingarea1_configure_event (GtkWidget   *widget, GdkEventConfigure *event, gpointer  user_data);

void mainwindow_resize_callback (image_type *img, int newx, int newy);

gboolean on_drawingarea1_key_press_event (GtkWidget   *widget, GdkEventKey *event, gpointer  user_data);

gboolean on_drawingarea1_clicked_event (GtkWidget *widget, GdkEventKey *event, gpointer user_data);

gboolean on_drawingarea1_click_released_event (GtkWidget *widget, GdkEventKey *event, gpointer user_data);

gint on_drawingarea1_motion_notify_event  (GtkWidget *widget, GdkEventMotion *event, gpointer user_data);


///void on_hscrollbar1_motion (GtkWidget *widget, GdkEventKey *event, gpointer user_data);

///void on_vscrollbar1_motion (GtkWidget *widget, GdkEventKey *event, gpointer user_data);

gboolean on_drawingarea1_enter_notify_event (GtkWidget *widget, GdkEventCrossing *event, gpointer user_data);
gboolean on_drawingarea1_leave_notify_event (GtkWidget *widget, GdkEventCrossing *event, gpointer user_data);

gboolean on_drawingarea1_scroll_event  (GtkWidget *widget, GdkEventButton *event, gpointer user_data);


///void on_checkbutton1_toggled   (GtkToggleButton *togglebutton, gpointer  user_data);


#endif

